<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

OW::getRouter()->addRoute(new OW_Route('newsfeed_admin_settings', 'admin/plugins/newsfeed', 'NEWSFEED_CTRL_Admin', 'index'));

$eventHandler = new NEWSFEED_CLASS_EventHandler;

OW::getEventManager()->bind('feed.action', array($eventHandler, 'action'));
OW::getEventManager()->bind('feed.after_like_added', array($eventHandler, 'addLike'));
OW::getEventManager()->bind('feed.install_widget', array($eventHandler, 'installWidget'));
OW::getEventManager()->bind('feed.after_status_update', array($eventHandler, 'statusUpdate'));
OW::getEventManager()->bind('feed.delete_item', array($eventHandler, 'deleteAction'));
OW::getEventManager()->bind('feed.get_status', array($eventHandler, 'getStatus'));
OW::getEventManager()->bind('feed.add_follow', array($eventHandler, 'addFollow'));
OW::getEventManager()->bind('feed.remove_follow', array($eventHandler, 'removeFollow'));
OW::getEventManager()->bind('feed.is_follow', array($eventHandler, 'isFollow'));

OW::getEventManager()->bind('base_add_comment', array($eventHandler, 'addComment'));
OW::getEventManager()->bind('friends.request-accepted', array($eventHandler, 'addFriend'));
OW::getEventManager()->bind('friends.cancelled', array($eventHandler, 'removeFriend'));
OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_PLUGIN_DEACTIVATE, array($eventHandler, 'onPluginDeactivate'));
OW::getEventManager()->bind(OW_EventManager::ON_AFTER_PLUGIN_ACTIVATE, array($eventHandler, 'onPluginActivate'));
OW::getEventManager()->bind(OW_EventManager::ON_BEFORE_PLUGIN_UNINSTALL, array($eventHandler, 'onPluginUninstall'));

OW::getEventManager()->bind('base.on_get_user_status', array($eventHandler, 'getUserStatus'));

function newsfeed_on_collect_profile_actions( BASE_CLASS_EventCollector $event )
{
    $params = $event->getParams();
    $userId = $params['userId'];
     
    if ( OW::getUser()->getId() == $userId )
    {
        return;
    }
    
    $urlParams = array(
        'userId' => $userId,
        'backUri' => OW::getRouter()->getUri()
    );
    
    if ( NEWSFEED_BOL_Service::getInstance()->isFollow(OW::getUser()->getId(), 'user', $userId) )
    {
        $url = OW::getRouter()->urlFor('NEWSFEED_CTRL_Feed', 'unFollow');
        $label = OW::getLanguage()->text('newsfeed', 'unfollow_button');            
    }
    else 
    {
        $url = OW::getRouter()->urlFor('NEWSFEED_CTRL_Feed', 'follow');
        $label = OW::getLanguage()->text('newsfeed', 'follow_button');
    }
    
    $event->add(array(
        BASE_CMP_ProfileActionToolbar::DATA_KEY_LABEL => $label,
        BASE_CMP_ProfileActionToolbar::DATA_KEY_LINK_HREF => OW::getRequest()->buildUrlQueryString($url, $urlParams)
    ));
}
OW::getEventManager()->bind(BASE_CMP_ProfileActionToolbar::EVENT_NAME, 'newsfeed_on_collect_profile_actions');

function newsfeed_is_feed_inited()
{
    return true;
}
OW::getEventManager()->bind('feed.is_inited', 'newsfeed_is_feed_inited');

function newsfeed_ads_enabled( BASE_EventCollector $event )
{
    $event->add('newsfeed');
}

OW::getEventManager()->bind('ads.enabled_plugins', 'newsfeed_ads_enabled');